<?

function cyr2lat($s) {
 $cyr = array('А','Б','В','Г','Д','Е','З','И','Й','К','Л','М','Н','О','П','Р','С','Т','У','Ф','Х','Ъ','Ы','Ь','Э',
	             'а','б','в','г','д','е','з','и','й','к','л','м','н','о','п','р','с','т','у','ф','х','ъ','ы','ь','э',
														'і','ї','ё','ж','ц','ч','ш','щ','ю','я','Ё','Ж','Ц','Ч','Ш','Щ','Ю','Я','І','Ї', '(', ')');
 $lat = array('A','B','V','G','D','E','Z','I','J','K','L','M','N','O','P','R','S','T','U','F','H','_','I','_','E',
	             'a','b','v','g','d','e','z','i','j','k','l','m','n','o','p','r','s','t','u','f','h','_','i','_','e',
														'i','ji','yo','zh','tc','ch','sh','sh','yu','ya','YO','ZH','TC','CH','SH','SH','YU','YA', 'I', 'JI', '', '');
 return str_replace($cyr, $lat, $s);
}

function cut_str ($s, $n){
  $sep = array(" ", ".", ",", "!", "?", ")", "-", ";", ":");
  if (strlen($s) <= $n) {
    return  $s;
  } else {
    $t = substr($s, 0, $n-3);
	// find one of the separators at the end of $t
	$i = strlen($t)-1;
	while ($i >= 0) {
	  if (in_array($t[$i], $sep)) {
	    break;
	  } else {
	    $i--;	
	  }  
	}
	return substr($t, 0, $i+1)."...";
  }
}

function connect_hydra($cmd, $params, &$output, &$errors) {
	$process = proc_open($cmd, array(array("pipe", "r"), array("pipe", "w"), array("pipe", "w")), $pipes);
	if (is_resource($process)) {
		fwrite($pipes[0], $params);
		fclose($pipes[0]);
 	$out .= substr(stream_get_contents($pipes[1]), 1, -1);	// JSON encoded output, first and last braces stripped
		fclose($pipes[1]);
		$errors .= stream_get_contents($pipes[2]);
		fclose($pipes[2]);
		$return_value = proc_close($process);		
	} else
		$errors .= "proc_open() failed. \n";
	$output .= ($output ? ',' : '').$out;
}

$_php_errors = '';
function error_handler($errno, $errstr, $errfile, $errline) {
 global $_php_errors;
	
	$_php_errors .= $errfile.', line '.$errline.': '.$errstr."\n";
	
	return true;
}

set_error_handler(error_handler, E_ALL^E_NOTICE);
?>