drop table if exists `dictionary`	;
CREATE TABLE `dictionary` (
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `value_1` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Українська',
  `value_2` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'English',
  `value_3` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Deutsch',
  `value_4` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Svenska',
  `value_5` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Norske',
  `value_6` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Italiano',
  `value_7` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Español',
  `value_8` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Française',
  `value_9` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Suomi',
  `value_10` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Български',
  `value_11` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'České',
  `value_12` varchar(255) COLLATE utf8_unicode_ci NOT NULL COMMENT 'Русский',
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
insert into `dictionary` VALUES 
("{0} директорій","{0} директорій","{0} folders","{0} Ordner","","","","","{0} dossiers","","{0} директории","{0} složky","{0} директорий"),
("{0} файлів","{0} файлів","{0} files","{0} Dateien","","","","","{0} fichiers","","{0} файл","{0} souborů","{0} файлов"),
("ID користувача","ID користувача","User ID","Benutzer ID","","","","","ID d\'utilisateur","","ID на потребител","ID uživatelu","ID пользователя"),
("Адреса","Адреса","Address","Adresse","","","","","Adresse","","Адрес","Adresa","Адрес"),
("Архівувати виділені файли чи директорії","Архівувати виділені файли чи директорії","Archive selected files or folders","","","","","","Archiver des fichiers ou dossiers sélectionnés","","Архивиране на избраните файлове или директории","Archiv vybrané soubory či složky","Архивировать выделенные файлы или каталоги"),
("Атрибути","Атрибути","Attributes","Attributen","","","","","Attributs","","Атрибути","Atributy","Атрибуты"),
("Атрибути файлів","Атрибути файлів","File Attributes","Dateiattribute","","","","","Les attributs de fichiers","","Файловите атрибути","Atributy souborů","Атрибуты файлов"),
("Домашня тека","Домашня тека","Home folder","Home-Ordner","","","","","Accueil dossier","","Начало Папка","Domovská složka","Домашняя папка"),
("Введіть назву нової директорії в<br />{0}","Введіть назву нової директорії в<br />{0}","Enter name of new folder in<br />{0}","","","","","","Entrez le nom du nouveau dossier dans<br />{0}","","Въведете името на новата директория в<br /> {0}","Zadejte název nové složky v<br /> {0}","Введите имя новой директории в<br /> {0}"),
("Виберіть задачу","Виберіть задачу","Select task","Wählen Sie Aufgabe","","","","","Choisissez la tâche","","Изберете задача","Vyberte úkol","Выберите задачу"),
("Виберіть компілятор","Виберіть компілятор","Select compiler","Wählen Sie einen Compiler","","","","","Choisissez le compilateur","","Изберете съставител","Vyberte kompilátor","Выберите компилятор"),
("Виберіть мову програмування","Виберіть мову програмування","Choose programming language","","","","","","Choisissez le langue de programmation","","Изберете език за програмиране","Vyberte programovací jazyk","Выберите язык программирования"),
("Виберіть один чи кілька файлів для закачування","Виберіть один чи кілька файлів для закачування","Select one or more files for uploading","","","","","","Choisissez un ou plusieurs fichiers à télécharger","","Изберете един или повече файлове за изтегляне","Vyberte jeden nebo několik souborů ke stažení","Выберите один или несколько файлов для закачки"),
("Видалення файлів","Видалення файлів","Delete Files","Löschen von Dateien","","","","","Supprimer des fichiers","","Изтриване на файлове","Mazání souborů","Удаление файлов"),
("Видалити","Видалити","Delete","Löschen","","","","","Supprimer","","Изтрийте","Odstranit","Удалить"),
("Видалити {0} файлів?","Видалити {0} файлів?","Delete {0} files?","Löschen {0} Datei?","","","","","Supprimer {0} des fichiers?","","Премахване на {0} файл?","Odstranit {0} souborů?","Удалить {0} файлов?"),
("Видалити виділену директорію чи файл","Видалити виділену директорію чи файл","Remove selected file or folder","","","","","","Supprimer le fichier ou le dossier sélectionné","","Премахване на избраната директория или файл","Odstranění vybraného souboru nebo složky","Удалить выделенную директорию или файл"),
("Використати як файл для виконання","Використати як файл для виконання","Use as task executable","","","","","","Utiliser comme le fichier exécutable","","Използва се като файл, за да изпълнява","Použijte soubor vykonávat","Использовать как файл для выполнения"),
("Використовувався днів тому","Використовувався днів тому","Accessed days ago","","","","","","Utilisés il ya jours","","Използвани дни назад ","Používá před dny","Использовался дней назад"),
("Вирізати","Вирізати","Cut","Ausschälen","","","","","Couper","","Изрежете","Vystřihnout","Вырезать"),
("Вихідні файли","Вихідні файли","Output Files","Ausgangdateien","","","","","Les fichiers sources","","Източник файлове","Zdrojové soubory","Исходные файлы"),
("Відправник","Відправник","Sender","Absender","","","","","Expéditeur","","Подател","Odesílatel","Отправитель"),
("Вісімковий код","Вісімковий код","Octal code","Oktalcode","","","","","Code octal","","Осмичен код","Osmičkový kód","Восьмеричный код"),
("Вкажіть кількість процесорних ядер","Вкажіть кількість процесорних ядер","Specify number of processor cores","","","","","","Spécifiez le nombre de cœurs de processeur","","Посочете броя на процесорните ядра","Zadejte počet procesorových jader","Укажите количество процессорных ядер"),
("Вкажіть ліміт часу на виконання задачі","Вкажіть ліміт часу на виконання задачі","Specify task time limit","","","","","","Spécifiez la limite de temps de travail","","Определя срок за завършване на задачите","Zadejte lhůtu pro daný úkol","Укажите лимит времени на выполнение задачи"),
("Вкажіть назву задачі","Вкажіть назву задачі","Specify task name","","","","","","Spécifiez le nom de la tâche","","Въведете името на задачата","Zadejte jméno úkolu","Укажите название задачи"),
("Вкажіть файл для виконання (файл скрипта)","Вкажіть файл для виконання (файл скрипта)","Specify task executable (script file)","","","","","","Spécifiez la tâche exécutable (fichier script)","","Посочете файл за изпълнение (на скрипта)","Zadejte soubor pro spuštění (skript)","Укажите файл для выполнения (файл скрипта)"),
("Власник","Власник","Owner","Eigentümer","","","","","Propriétaire","","Собственик","Vlastník","Владелец"),
("Вперед","Вперед","Forward","Vorwärts","","","","","En avant","","Следваща","Vpřed","Вперед"),
("Вставити","Вставити","Paste","Einfügen","","","","","Intégrer","","Закрепвам","Vložit","Вставить"),
("Вхідні файли","Вхідні файли","Input Files","Eingangdateien","","","","","Les fichiers entrants","","Входящите файлове","Vstupních souborů","Входящие файлы"),
("Графік","Графік","Graph","Schautafel","","","","","Graphique","","Разписание","Graf","График"),
("Група","Група","Group","Gruppe","","","","","Groupe","","Група","Skupina","Группа"),
("Групування","Групування","Grouping","Gruppierung","","","","","Groupement","","Групировка","Seskupení","Группировка"),
("Дата","Дата","Date","Datum","","","","","Date","","Дата","Datum","Дата"),
("Дії","Дії","Actions","Aktionen","","","","","Actions","","Действия","Akce","Действия"),
("Додати","Додати","Add","Hinzufügen","","","","","Ajouter","","Добави","Přidat","Добавить"),
("Додати X для директорій","Додати X для директорій","Add X to folders","Hinzufüge X auf Ordner","","","","","Ajouter X à des dossiers","","Добави X за директории","Přidat X pro složky","Добавить X для директорий"),
("Додати до параметрів задачі","Додати до параметрів задачі","Add to task parameters","","","","","","Ajouter à paramètres des tâches","","Добави към параметрите на проблема","Přidat k parametrům ukolu","Добавить к параметрам задачи"),
("Експорт в CSV","Експорт в CSV","Export to CSV","","","","","","L\'exportation vers CSV","","Износ за CSV","Export do formátu CSV","Экспорт в CSV"),
("За користувачами","За користувачами","By users","Benutzernlich","","","","","Par les utilisateurs","","За потребителите","Pro uživatele","По пользователям"),
("За організаціями","За організаціями","By organizations","","","","","","Par les organisations","","За организации","Pro organizace","По организациям"),
("Завантаження...","Завантаження...","Loading...","Laden...","","","","","Charge...","","Зареждане...","Načítání...","Загрузка..."),
("завершення з помилкою","завершення з помилкою","error","Fehler","","","","","terminaison avec erreur","","прекратяване с грешка","kompletní s chybou","завершение с ошибкой"),
("Заданий користувачем","Заданий користувачем","User specified","","","","","","Défini par l\'utilisateur","","Потребителски-дефинирани","Uživatel-definované","Заданное пользователем"),
("Задача","Задача","Task","Aufgabe","","","","","Tâche","","Проблем","Ukol","Задача"),
("Закачати файли","Закачати файли","Upload files","Dateien hochladen","","","","","Transférer des fichiers","","Качване на файл","Soubory ke stažení","Закачать файлы"),
("Залежність від задачі","Залежність від задачі","Dependency of task","","","","","","La dépendance de la tâche","","Зависимост от задачата","Závislosti na ukolu","Зависимость от задачи"),
("Запис змінено","Запис змінено","Record changed","","","","","","Notice modifié","","Записът е промяна","Záznam změněn","Запись изменена"),
("Запис створено","Запис створено","Record created","","","","","","Notice créé","","Създадена сметка","Záznam vytvořen","Запись создана"),
("Запуск","Запуск","Launch","Starten","","","","","Lancement","","Стартиране","Zahájení","Запуск"),
("Запуск задач","Запуск задач","Launch tasks","Launch Aufgaben","","","","","Lancement des tâches","","Стартиране проблеми","Zahájení ukolu","Запуск задач"),
("Запуски","Запуски","Launches","Starten","","","","","Lancements","","Стартирани","Spustí","Запуски"),
("Зберегти","Зберегти","Save","Sparen","","","","","Sauver","","Запиши","Uložit","Сохранить"),
("Згенерувати ключі","Згенерувати ключі","Generate keys","Generieren Schlüssel","","","","","Générer des clés","","Генериране на ключове","Generovat klíče","Сгенерировать ключи"),
("Змінений днів тому","Змінений днів тому","Modified days ago","","","","","","Modifié il ya jours","","Променени дни назад","Změněný před dny","Изменен дней назад"),
("Ім\'я","Ім\'я","Name","Name","","","","","Nom","","Име","Název","Имя"),
("Ім\'я задачі","Ім\'я задачі","Task name","Aufgabename","","","","","Nom de la tâche","","Задача име","Název ukolu","Имя задачи"),
("Ім\'я файла","Ім\'я файла","File name","Dateiname","","","","","Nom du fichier","","Име на файла","Název souboru","Имя файла"),
("Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\'","Ім\'я файла чи директорії має складатись з літер, цифр та знаків: \'_\', \'-\', \'.\'","File or folder name should consist of letters, digits and signs: \'_\', \'-\', \'.\'","","","","","","Nom du fichier ou dossier doit consister des lettres, chiffres et symboles: \'_\', \'-\', \'.\'","","Името на файл или директория трябва да се състои от букви, цифри и символи: \'_\', \'-\', \'.\'","Jméno souboru nebo složky je složen z písmen, čísel a znaků: \'_\', \'-\', \'.\'","Имя файла или директории должно состоять из букв, цифр и знаков: \'_\', \'-\', \'.\'"),
("Інші","Інші","Other","Andere","","","","","Autres","","Другия","Ostatní","Другие"),
("Категорія","Категорія","Category","Kategorie","","","","","Catégorie","","Категория","Kategorie","Категория"),
("Кількість запусків","Кількість запусків","Launch count","Anzahl der Starts","","","","","Nombre des lancements","","Броят на стартира","Počet startů","Количество запусков"),
("Кількість ядер","Кількість ядер","Cores count","Kerne zählen","","","","","Nombre des cœurs","","Брой ядра на процесора","Počet jader","Количество ядер"),
("Кінцева дата","Кінцева дата","End date","Letzter Tag ","","","","","Date de fin","","Крайна дата","Datum ukončení","Конечная дата"),
("Компілятор","Компілятор","Compiler","Kompilator","","","","","Compilateur","","Съставител","Kompilátor","Компилятор"),
("Компіляція","Компіляція","Compilation","Kompilation","","","","","Compilation","","Компилация","Sestavení","Компиляция"),
("Користувач","Користувач","User","Benutzer","","","","","Utilisateur","","Потребител","Uživatel","Пользователь"),
("Користувачі","Користувачі","Users","Benutzeren","","","","","Utilisateurs","","Потребители","Uživatelé","Пользователи"),
("Крок статистики","Крок статистики","Statistics step","","","","","","Pas des statistiques","","Стъпка статистика","Krok statistiky","Шаг статистики"),
("Ліміт часу, хв","Ліміт часу, хв","Timelimit, min","Zeitgrenze, min","","","","","Délai, min","","Срокът, мин","Časový limit, min","Лимит времени, мин"),
("Мова програмування","Мова програмування","Programming language","Programmiersprache","","","","","Langue de programmation","","Език за програмиране","Programovací jazyk","Язык программирования"),
("Моніторинг","Моніторинг","Monitoring","Überwachung","","","","","Surveillance","","Мониторинг","Monitorování","Мониторинг"),
("На рівень вище","На рівень вище","Up folder","","","","","","Niveau supérieur","","За по-високо ниво","O úroveň výš","На уровень выше"),
("Навантаження","Навантаження","Load","Laden","","","","","Charge","","Натоварване","Zatížení","Нагрузка"),
("Навантаження, CPU x секунд","Навантаження, CPU x секунд","Load, CPU x seconds","","","","","","Charge, CPU x seconde","","Натоварване, CPU х секунди","Zatížení CPU x sekund","Нагрузка, CPU x секунд"),
("Навантаження, годин х ядро","Навантаження, годин х ядро","Load, hours x core","","","","","","Charge, heures x cœur","","Натоварване часа х ядрото","Zatížení, hod x jádro","Нагрузка, часов х ядро"),
("Надіслати","Надіслати","Send","Senden","","","","","Envoyer","","Изпрати","Poslat","Отправить"),
("Назад","Назад","Back","Zurück","","","","","Revenir","","Обратно","Zpět","Назад"),
("немає залежності","немає залежності","no dependence","keine Abhängigkeit","","","","","pas de la dépendance","","няма зависимостта","bez závislosti","нет зависимости"),
("Немає повідомлень","Немає повідомлень","No messages","Keine Nachricht","","","","","Pas de messages","","Няма публикации","Žádné příspěvky","Нет сообщений"),
("Оберіть розділ кластера","Оберіть розділ кластера","Choose cluster partition","","","","","","Choisissez la section du cluster","","Изберете раздел група","Vyberte část clusteru","Выберите раздел кластера"),
("Обчислити розмір","Обчислити розмір","Calculate size","Größe berechnen","","","","","Сalculer la grandeur","","Изчислява размер","Vypočítejte velikost","Вычислить размер"),
("Одержувач","Одержувач","Recipient","Empfänger","","","","","Destinataire","","Получател","Příjemce","Получатель"),
("Опис","Опис","Description","Beschreibung","","","","","Description","","Описание","Popis","Описание"),
("Організації: навантаження, %","Організації: навантаження, %","Organizations: load, %","","","","","","Organisations: charge, %","","Организация: натоварване, %","Organizace: zatížení, %","Организации: нагрузки,%"),
("Організація","Організація","Organization","Organisation","","","","","Organisation","","Организация","Organizace","Организация"),
("Очистити","Очистити","Reset","Klären","","","","","Nettoyer","","Ясно","Jasný","Очистить"),
("Параметри задачі","Параметри задачі","Task parameters","Aufgabeparameter","","","","","Paramètres de la tâche","","Параметри на проблема","Parametry ukolu","Параметры задачи"),
("Перегляд файла","Перегляд файла","View File","Datei anzeigen","","","","","Voir le fichier","","Преглед на файла","Zobrazit soubor","Просмотр файла"),
("Перейменувати","Перейменувати","Rename","Umbenennen","","","","","Renommer","","Преименувам","Přejmenovat","Переименовать"),
("Перейти","Перейти","Go","Gehen","","","","","Passer","","Продължи","Jdi","Перейти"),
("Період","Період","Period","Zeitraum","","","","","Période","","Период","Období","Период"),
("По днях","По днях","Daily","Täglich","","","","","Par jours","","Дневно","Podle dnů","По дням"),
("По місяцях","По місяцях","Monthly","Monatliche","","","","","Par moises","","Месечен","Podle měsících","По месяцам"),
("По роках","По роках","Yearly","Jährlich","","","","","Par années","","По година","Podle roku","По годам"),
("По тижнях","По тижнях","Weekly","Wochelich","","","","","Par semaines","","Седмично","Podle týden","По неделям"),
("Повідомлення","Повідомлення","Messages","Nachrichten","","","","","Message","","Съобщение","Zpráva","Сообщения"),
("Повідомлення {0} - {1} з {2}","Повідомлення {0} - {1} з {2}","Messages {0} - {1} of {2}","","","","","","Messages {0} - {1} de {2}","","Съобщение {0} - {1} з {2}","Zpráva {0} - {1} z {2}","Сообщение {0} - {1} з {2}"),
("Помилка","Помилка","Error","Fehler","","","","","Erreur","","Грешка","Chyba","Ошибка"),
("Початкова дата","Початкова дата","Start date","Erster Tag","","","","","Date du début","","Начална дата","Datum zahájení","Начальная дата"),
("Пошук файлів","Пошук файлів","Search files","Dateien suchen","","","","","Rechercher des fichiers","","Търсене на файлове","Najít soubory","Поиск файлов"),
("Права","Права","Permissions","Berechtigungen","","","","","Autorisations","","Право","Právo","Права"),
("Профілі","Профілі","Profiles","Profilen","","","","","Profils","","Профили","Profily","Профили"),
("Профіль","Профіль","Profile","Profil","","","","","Profil","","Профил","Profil","Профиль"),
("Разом","Разом","Together","Alle","","","","","Ensemble","","Заедно","Společně","Вместе"),
("Регулярний вираз","Регулярний вираз","Regular Expression","","","","","","Expression régulière","","Регулярен израз","Regulární výraz","Регулярное выражение"),
("Рекурсивно","Рекурсивно","Recursively","Rekursiv","","","","","Récursivement","","Рекурсивно","Rekurzivní","Рекурсивно"),
("Ресурси","Ресурси","Resources","Ressourcen","","","","","Ressources","","Ресурси","Zdroje","Ресурсы"),
("Розархівувати виділені архіви","Розархівувати виділені архіви","Unzip selected archives","","","","","","Décompresser les archives sélectionnés","","Разархивирайте избрани архив","Odarchivovat vybrané archiv","Разархивировать выделенные архивы"),
("Розмір","Розмір","Size","Größe","","","","","Grandeur","","Размер","Velikost","Размер"),
("Розташування","Розташування","Location","Ort","","","","","Emplacement","","Местоположение","Místo","Расположение"),
("Середній час обчислень","Середній час обчислень","Average computing time","Mittler Kalkulationzeit","","","","","Moyen temps du calcul ","","Средното време за изчисляване","Průměrná doba výpočtu","Среднее время вычислений"),
("Середній час обчислень, годин","Середній час обчислень, годин","Average computing time, hours","","","","","","","","","","Среднее время вычислений, часов"),
("Черга","Черга","Queue","Warteschlange","","","","","","","","","Очередь"),
("Середній час, годин","Середній час, годин","Average time, hours","Mittler Zeit, Stunden","","","","","Moyen temps, les heures","","Средно време, часа","Průměrná doba, hodin","Среднее время, часов"),
("Скасувати","Скасувати","Cancel","Abbrechen","","","","","Annuler","","Отказът","Zrušit","Отменить"),
("Скопіювати","Скопіювати","Copy","Kopieren","","","","","Copier","","Копие","Kopie","Скопировать"),
("Скрипт запуску","Скрипт запуску","Launch Script","Startskript","","","","","Script du lancement ","","Стартирания скрипт","Skript zahájení","Скрипт запуска"),
("Створення директорії","Створення директорії","New Folder","Neuer Ordner","","","","","Nouveau dossier","","Създаване на директория","Vytvořte slozku","Создание директории"),
("Сумарне навантаження","Сумарне навантаження","Total load","Gesamtlast","","","","","La charge totale","","Общо натоварване","Celkové zatížení","Суммарная нагрузка"),
("Так","Так","OK","Ja","","","","","Oui","","Да","Ano","Да"),
("Текст повідомлення","Текст повідомлення","Message","Nachricht","","","","","Message","","Текстът съобщения","Zpráva","Текст сообщения"),
("Телефон","Телефон","Phone","Telefon","","","","","Téléphone","","Телефонът","Telefon","Телефон"),
("Тема","Тема","Subject","Thema","","","","","Objet","","Тема","Předmět","Тема"),
("Тема повідомлення","Тема повідомлення","Message subject","Thema Nachrichten","","","","","Objet du message","","Тема Съобщения","Předmět","Тема сообщения"),
("Тип","Тип","Type","Typ","","","","","Type","","Тип","Typ","Тип"),
("Умова залежності","Умова залежності","Dependence condition","Abhängigkeit Zustand","","","","","Condition de la dépendance ","","Състояние на зависимостта","Podmínka závislost","Условие зависимости"),
("успішне завершення","успішне завершення","successful finish","erfolgreich beenden","","","","","terminaison avec succès","","успешно завършване","úspěšném absolvování","успешное завершение"),
("Файл","Файл","File","Datei","","","","","Fichier","","Файл","Soubor","Файл"),
("Файл для виконання","Файл для виконання","Executable file","","","","","","Fichier exécutable","","Файл, за да изпълнява","Soubory ke spuštění","Файл для выполнения"),
("Форма запуску","Форма запуску","Launch Form","Startform","","","","","Forme du lancement","","Стартирания форма","Formulář zahájení","Форма запуска"),
("Час зміни","Час зміни","Modification Time","Änderungszeit","","","","","Date de la modification","","Време за промяна","Změně času","Время изменения"),
("Кластер та черга","Кластер та черга","Cluster and queue","Cluster und Warteschlangen","","","","","Cluster et queue","","","","Кластеры и очереди"),
("Шукати","Шукати","Search","Suche","","","","","Chercher","","Търсене","Vyhledávání","Искать"),
("Файл скрипта","Файл скрипта","Script file","Skriptdatei","","","","","Fichier du script","","Сценарият на файла","Soubor skriptu","Файл скрипта"),
("Увійти до системи керуванння кластером","Увійти до системи керуванння кластером","Login to cluster management system","Geben Sie in das Klasterleitsystem","","","","","Entrer dans le système de la gestion du cluster","","","Zadejte v systému managementu clusteru","Войти в систему управления кластером"),
("Доступний","Доступний","Available","Verfügbar","","","","","Disponible","","","Dostupný","Доступный"),
("Стан","Стан","Status","Zustand","","","","","Statut","","","Stav","Состояние"),
("Недоступний","Недоступний","Not available","Unzugänglich","","","","","Non disponible","","","Nedostupný","Недоступный"),
("Розділ","Розділ","Partition","Abschnitt","","","","","Partition","","","Oddíl","Раздел"),
("Кластер","Кластер","Cluster","Cluster","","","","","Cluster","","","Cluster","Кластер"),
("Вузлів","Вузлів","Nodes","Knoten","","","","","Nœuds","","","Uzlů","Узлов"),
("Ядер","Ядер","Cores","Kernen","","","","","Cœurs","","","Jádra","Ядер"),
("Ліміт часу","Ліміт часу","Timelimit","Zeitgrenze","","","","","Délai","","","Časový limit","Лимит времени"),
("Оновити","Оновити","Refresh","Aktualisieren","","","","","Actualiser","","","Aktualizovat","Обновить"),
("Докладно","Докладно","Details","Detail","","","","","Détails","","","Podrobnosti","Подробно"),
("Виконується","Виконується","Running","Machen","","","","","Marche","","","Pracuje","Выполняется"),
("Очікує","Очікує","Waiting","Erwarten","","","","","Attente","","","Čekání","Ожидает"),
("Завершена","Завершена","Finished","Geschlossen","","","","","Finale","","","Dokončena","Завершена"),
("Скасована","Скасована","Cancelled","Abgesagt","","","","","Annulé","","","Zrušena","Отменена"),
("Завершена з помилкою","Завершена з помилкою","Failed","Fehler","","","","","Échoué","","","Dokončena s chybou","Завершилась с ошибкой"),
("Вийшов час","Вийшов час","Timeout","","","","","","Temps expiré","","","Čas je nahoru","Истекло время"),
("Збій вузла","Збій вузла","Node Fail","Absturzstelle","","","","","Nœud échoué","","","Havárie uzlu","Сбой узла"),
("Час роботи","Час роботи","Work time","Arbeitszeit","","","","","Temps du travail","","","Čas práci","Время работы"),
("Скасувати задачу {0}?","Скасувати задачу {0}?","Cancel task {0}?","Abbrechen eines Ausgabe {0}?","","","","","Annuler la tâche {0}?","","","Zrušit ukol {0}?","Отменить задачу {0}?"),
("Історія запусків","Історія запусків","Launch history","Geschichte von Arbeiten","","","","","Histoire des lancements","","","Historie zahájení","История запусков"),
("Персональні дані","Персональні дані","Personal data","Persönlichedaten","","","","","Les données personnelles","","","Osobní datové","Персональные данные"),
("Мова інтерфейсу","Мова інтерфейсу","Interface language","Schnittstelleschprahe","","","","","Langue de l\'interface","","","Jazyk rozhraní","Язык интерфейса"),
("Налаштування інтерфейсу","Налаштування інтерфейсу","Interface settings","Schnittstelle Einstellung","","","","","Réglages de l\'interface","","","Nastavení rozhraní","Настройки интерфейса"),
("Введені паролі не співпадають","Введені паролі не співпадають","Passwords entered do not match","Die Passwörter stimmen nicht überein","","","","","Mots de passe entré ne correspondent pas","","","Hesla se neshodují","Введенные пароли не совпадают"),
("Інформація про сертифікат","Інформація про сертифікат","Certificate information","Informationen zum Zertifikat","","","","","Information du certificat","","","Certifikát informace","Информация о сертификате"),
("Налаштування гріда","Налаштування гріда","Grid settings","Grid Einstellungen","","","","","Réglages de la grille","","","Nastavení gridu","Настройки грида"),
("Автоматичний вхід","Автоматичний вхід","Autologin","Automatische Login","","","","","Entrée automatique","","Автоматично влизане","Automaticky-přihlášení","Автоматический вход"),
("Сертифікат гріда","Сертифікат гріда","Grid certificate","Grid Zertifikat","","","","","Certificat de la grille","","","Grid certifikát","Сертификат грида"),
("Файл сертифікату","Файл сертифікату","Certificate file","Zertifikat Datei","","","","","Fichier du certificat","","","Soubor certifikátu","Файл сертификата"),
("Файл ключа","Файл ключа","Key file","Schlüssel Datei","","","","","Fichier de la clef","","","Soubor klíče","Файл ключа"),
("Видавець: {0}\\nВласник: {1}\\nДійсний з: {2}\\nДійсний до: {3}","Видавець: {0}\\nВласник: {1}\\nДійсний з: {2}\\nДійсний до: {3}","Issuer: {0}\\nOwner: {1}\\nValid from: {2}\\nValid to: {3}","","","","","","Editeur: {0} \\nPropriétaire: {1} \\nValide de: {2} \\nValide à: {3}","","","Vydavatel: {0} \\ nSobstvennik: {1} \\ nDeystvitelny s: {2} \\ nDeystvitelny na: {3}","Издатель: {0}\\nСобственник: {1}\\nДействительный с: {2}\\nДействительный до: {3}"),
("Змінити користувача","Змінити користувача","Change user","Benutzer wechseln","","","","","Changer d\'utilisateur","","","Změnit uživatele","Сменить пользователя"),
("Увійти в грід","Увійти в грід","Login in Grid","Loginen im Grid","","","","","Enterer dans la grille","","","Přihlásit do gridu","Войти в грид"),
("Вихід","Вихід","Log out","Ausgang","","","","","Quitter","","","Výjezd","Выйти"),
("Задачі","Задачі","Tasks","Aufgaben","","","","","Tâches","","","Úkoly","Задачи"),
("Мапа гріда","Мапа гріда","Grid map","Grid Karte","","","","","Carte de la grille","","","Mapa gridu","Карта грида"),
("Налаштування","Налаштування","Settings","Einstellungen","","","","","Paramètres","","","Nastavení","Настройки"),
("Статистика","Статистика","Statistics","Statistik","","","","","Statistiques","","","Statistiky","Статистика"),
("грід","грід","grid","grid","","","","","grille","","","grid","грид"),
("Пароль","Пароль","Password","Passwort","","","","","Mot de passe","","","Heslo","Пароль"),
("Підтвердження паролю","Підтвердження паролю","Confirm password","Passwort Wiederholung","","","","","Confirmation de mot de passe","","","Potvrzení hesla","Подтверждение пароля"),
("Додаткова інформація","Додаткова інформація","Details","Detail","","","","","Détails","","","Více","Дополнительная информация"),
("Ім\'я користувача","Ім\'я користувача","User name","Benutzername","","","","","Nom d\'utilisateur","","","Uživatelské jméno","Имя пользователя"),
("Підключення","Підключення","Connection","Verbindung","","","","","Connexion","","","Připojení","Подключение"),
("Введіть пароль","Введіть пароль","Enter password","Bitte geben Sie ihr Passwort ein","","","","","Entrez le mot de passe","","","Zadejte heslo","Введите пароль"),
("Введені облікові дані користувача є помилковими.","Введені облікові дані користувача є помилковими.","Login or password are incorrect.","Ihr Benutzername oder Passwort war nicht korrekt.","","","","","Nom d\'utilisateur ou mot de passe sont incorrect.","","","Nesprávné zadání pověření uživatele.","Введенны неверные учетные данные пользователя."),
("Перевірка даних...","Перевірка даних...","Checking data...","Prüfung der Daten...","","","","","Vérification des données...","","","Kontrola datové...","Проверка данных..."),
("Помилка входу","Помилка входу","Login error","","","","","","Erreur d\'entrée","","","Chyb při přihlášení","Ошибка входа"),
("Увійти","Увійти","Log in","Einloggen","","","","","Entrer","","","Přihlásit se","Войти"),
("Введіть ім\'я користувача","Введіть ім\'я користувача","Enter login","Bitte geben Sie ihren Benutzernamen ein","","","","","Entrez le nom d\'utilisateur","","","Zadejte uživatele jméno","Введите имя пользователя"),
("t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C","t, °C"),
("Сертифікат гріда недійсний або відсутній","Сертифікат гріда недійсний або відсутній","Grid certificate is invalid or absent","","","","","","Certificat de la grille est non valide ou manquant","","","Certifikát gridu nedeystvitelny nebo chybějící","Сертификат грида недействительный или отсутствует"),
("Вийти з грід","Вийти з грід","Exit grid","","","","","","Quitter la grille","","","Výjezd gridu","Выйти из грида"),
("Файлове сховище","Файлове сховище","File storage","","","","","","Dépôt des fichiers","","","","Файловое хранилище"),
("Жосткі диски","Жосткі диски","Hard disks","","","","","","Disques dur ","","","","Жесткие диски"),
("Керування вузлами","Керування вузлами","Node management","","","","","","Gestion des nœuds","","","","Управление узлами"),
("Температура вузлів","Температура вузлів","Nodes temperature","","","","","","Température des nœuds","","","","Температура узлов"),
("Вхід в грід","Вхід в грід","Login grid","","","","","","Enterer dans la grille","","","Přihlásit do gridu","Вход в грид"),
("Введіть пароль гріда","Введіть пароль гріда","Enter grid password","","","","","","Entrez le mot de passe de la grille","","","Zadejte heslo gridu","Введите пароль грида"),
("Таблиця","Таблиця","Table","","","","","","Table","","","","Таблица"),
("Використання файлової системи","Використання файлової системи","Filesystem usage","","","","","","Utilisation du système des fichiers","","","","Использование файловой системы"),
("Стан у гріді","Стан у гріді","Grid status","","","","","","État dans la grille","","","","Состояние в гриде"),
("Мережа","Мережа","Network","","","","","","Réseau","","","","Сеть"),
("Сенсори IPMI","Сенсори IPMI","IPMI sensors","","","","","","","","","","Сенсоры IPMI"),
("Системний журнал","Системний журнал","System log","","","","","","","","","","Системный журнал"),
("GSM модем","GSM модем","GSM modem","GSM modem","","","","","GSM modem","","GSM модем","GSM modem","GSM модем"),
("По годинах","По годинах","By hours","Stundelich","","","","","","","","","По часам"),
("Вузли файлової системи Lustre","Вузли файлової системи Lustre","Nodes of Luste filesystem","","","","","","","","","","Узлы файловой системы Lustre"),
("Температура: {0} °C","Температура: {0} °C","Temperature: {0} °C","","","","","","","","","","Температура: {0} °C"),
("Перегляд файла {0}","Перегляд файла {0}","View file {0}","","","","","","","","","","Просмотр файла {0}"),
("Сформувати","Сформувати","Compose","","","","","","","","","","Сформировать"),
("Будь-який грід кластер","Будь-який грід кластер","Any grid cluster","","","","","","","","","","Любой грид кластер"),
("RSL файл","RSL файл","RSL file","RSL Datei","","","","","RSL fichier","","RSL файл","RSL soubor","RSL файл"),
("Заданий користувачем (RSL)","Заданий користувачем (RSL)","User specified (RSL)","","","","","","","","","","Заданный пользователем (RSL)"),
("Активний","Активний","Active","","","","","","","","","","Активный"),
("Вкажіть ім\'я задачі для збереження профілю","Вкажіть ім\'я задачі для збереження профілю","Please input task name to save profile","","","","","","","","","","Укажите имя задачи для сохранения профиля"),
("Ваш обліковий запис заблоковано","Ваш обліковий запис заблоковано","Your account is locked","","","","","","","","","","Ваша учетная запись заблокирована"),
("Введіть телефон","Введіть телефон","Enter Phone","","","","","","","","",""," Введите телефон"),
("Введіть E-mail","Введіть E-mail","Enter E-mail","","","","","","","","","","Введите E-mail"),
("Введіть організацію","Введіть організацію","Enter organization","","","","","","","","","","Введите организацию"),
("Підтвердження","Підтвердження","Confirmation","","","","","","","","","","Подтверждение"),
("Ви впевнені, що хочете видалити користувача?","Ви впевнені, що хочете видалити користувача?","Are you shure you want to delete user?","","","","","","","","","","Вы уверенны, что хотите удалить пользователя?"),
("Існуючі користувачі","Існуючі користувачі","Existing users","","","","","","","","","","Существующие пользователи"),
("Заявки на реєстрацію","Заявки на реєстрацію","Registration requests","","","","","","","","","","Заявки на регистрацию"),
("Ви впевнені, що хочете згенерувати ключі користувача?","Ви впевнені, що хочете згенерувати ключі користувача?","Are you shure you want to generate user keys?","","","","","","","","","","Вы уверенны, что хотите сгенерировать ключи для пользователя?"),
("Запити на реєстрацію","Запити на реєстрацію","Registration requests","","","","","","","","","","Запросы на регистрацию"),
("Новий пароль","Новий пароль","New password","","","","","","","","","","Новый пароль"),
("Змінити пароль","Змінити пароль","Change password","","","","","","","","","","Изменить пароль"),
("Введіть поточний пароль","Введіть поточний пароль","Enter current password","","","","","","","","","","Введите текущий пароль"),
("Ім\'я користувача (ID)","Ім\'я користувача (ID)","User name (ID)","","","","","","","","","","Имя пользователя (ID)"),
("Введіть новий пароль","Введіть новий пароль","Enter new password","","","","","","","","","","Введите новый пароль"),
("Підтвердіть новий пароль","Підтвердіть новий пароль","Confirm new password","","","","","","","","","","Подтвердите новый пароль"),
("Зберігати робочу теку при збереженні профілю","Зберігати робочу теку при збереженні профілю","Seve work directory when saving profile","","","","","","","","","","Сохранять рабочий каталог при сохранении профиля"),
("Робочий каталог","Робочий каталог","Working directory","","","","","","","","","","Рабочий каталог"),
("Середовище виконання","Середовище виконання","Runtime environment","","","","","","","","","","Рабочее окружение"),
("Опис профілю","Опис профілю","Profile description","","","","","","","","","","Описание профиля"),
("Введіть робочу теку задачі","Введіть робочу теку задачі","Enter work directory","","","","","","","","","","Введите рабочий каталог"),
("Журнал запусків","Журнал запусків","Submission Log","","","","","","","","","","Журнал запусков"),
("Інші параметри","Інші параметри","Other parameters","","","","","","","","","","Другие параметры"),
("Скачати файл","Скачати файл","Download file","","","","","","","","","","Скачать файл"),
("Перейти в локальну теку","Перейти в локальну теку","Go to local folder","","","","","","","","","","Перейти в локальную папку"),
("Надіслати повідомлення","Надіслати повідомлення","Send message","","","","","","","","","","Послать сообщение"),
("Реєстрація","Реєстрація","Registration","","","","","","","","","","Регистрация"),
("Опис проекту","Опис проекту","Project description","","","","","","","","","","Описание проекта"),
("Ім\'я користувача повинно складатись з літер, цифр, тире та підкреслення","Ім\'я користувача повинно складатись з літер, цифр, тире та підкреслення","Login should consist of letters, numbers, hyphen or underscore.","","","","","","","","","","Имя пользователя должно состоять из букв, цифр, тире или подчеркивания"),
("Зареєструвати","Зареєструвати","Register","","","","","","","","","","Зарегистрировать"),
("Реєстрація нового користувача","Реєстрація нового користувача","New user registration","","","","","","","","","","Регистрация нового пользователя"),
("П.І.Б.","П.І.Б.","Full name","","","","","","","","","","Ф.И.О."),
("Електронна адреса","Електронна адреса","E-mail","","","","","","","","","","Електронный адрес"),
("Рід занять","Рід занять","Business category","","","","","","","","","","Род деятельности"),
("Довжина паролю повинна бути не меншою за {0} символів","Довжина паролю повинна бути не меншою за {0} символів","The minimum length of password is {0} chars","","","","","","","","","","Минимальная длина пароля {0} символов"),
("Це поле є обов\'язковим","Це поле є обов\'язковим","This field is required","","","","","","","","","","Это поле обязательное"),
("Мінімальна довжина паролю - {0} символів","Мінімальна довжина паролю - {0} символів","Minimal length of password is {0} chars","","","","","","","","","","Минимальная длина пароля - {0} символов"),
("Успішна реєстрація","Успішна реєстрація","Registration success","","","","","","","","","","Успешная регистрация"),
("Вітаємо, {0}! Ваш запит на реєстрацію виконано успішно. Будь ласка, очікуйте підтвердження реєстрації від адміністратора кластера.","Вітаємо, {0}! Ваш запит на реєстрацію виконано успішно. Будь ласка, очікуйте підтвердження реєстрації від адміністратора кластера.","Greetings, {0}! Your registration request has been sent successfully. Please wait for cluster administration approval.","","","","","","","","","","Поздравляем, {0}! Ваш запрос на регистрацию успешно отправлен. Пожалуйста, ожидайте одобрения администрации кластера."),
("Ваш обліковий запис заблоковано.","Ваш обліковий запис заблоковано.","Your account is locked.","","","","","","","","","","Ваша учетная запись заблокирована."),
("Таке ім\'я користувача вже існує. Будь ласка, оберіть інше ім\'я користувача.","Таке ім\'я користувача вже існує. Будь ласка, оберіть інше ім\'я користувача.","This login already exists. Please choose other login.","","","","","","","","","","Такое имя пользователя уже существует. Пожалуйста, введите другое имя пользователя."),
("Помилка реєстрації","Помилка реєстрації","Registration failure","","","","","","","","","","Ошибка регистрации"),
("Будь ласка, заповніть усі поля.","Будь ласка, заповніть усі поля.","Please fill in all the fields.","","","","","","","","","","Пожалуйста, заполните все поля."),
("Введіть вірну електронну адресу в форматі \"user@example.com\"","Введіть вірну електронну адресу в форматі \"user@example.com\"","This field should be an e-mail address in the format \"user@example.com\"","","","","","","","","","","Введите верный электронный адрес в формате \"user@example.com\""),
("Робоча тека","Робоча тека","Working directory","","","","","","","","","","Рабочий каталог"),
("Додати користувача","Додати користувача","Add user","","","","","","","","","","Добавить пользователя"),
("Дата реєстрації","Дата реєстрації","Registration date","","","","","","","","","","Дата регистрации"),
("Введіть вірний телефонний номер","Введіть вірний телефонний номер","Phone number is invalid","","","","","","","","","","Введите верный номер телефона"),
("Складність паролю","Складність паролю","Password strength","","","","","","","","","","Сложность пароля"),
("Ваш пароль занадто слабкий.","Ваш пароль занадто слабкий.","Your password is too weak.","","","","","","","","","","Ваш пароль слишком прост."),
("Користувач {0} вже існує. Перезаписати?","Користувач {0} вже існує. Перезаписати?","User {0} exists. Overwrite?","","","","","","","","","","Пользователь {0} существует. Перезаписать?"),
("Зареєстрований","Зареєстрований","Registered","","","","","","","","","",""),
("Ви впевнені, що хочете видалити цей запит?","Ви впевнені, що хочете видалити цей запит?","Are you sure to delete this request?","","","","","","","","","","Вы уверены, что хотите удалить этот запрос?"),
("Діапазон дат","Діапазон дат","Dates range","","","","","","","","","","Диапазон дат"),
("Мінімальна довжина паролю - 6 символів, складність паролю - не менше 10.","Мінімальна довжина паролю - 6 символів, складність паролю - не менше 10.","Password must consist of at least 6 symbols with strength at least 10.","","","","","","","","","","Минимальная длина пароля - 6 символов, сложность пароля - не меньше 10."),
("Запит задоволено","Запит задоволено","Request satisfied","","","","","","","","","","Запрос удовлетворен"),
("Користувач існує","Користувач існує","User exists","","","","","","","","","","Пользователь существует"),
("Збереження користувача...","Збереження користувача...","Saving user...","","","","","","","","","","Сохранение пользователя..."),
("Користувача додано","Користувача додано","User added","","","","","","","","","","Пользователь добавлен"),
("Введіть назву нового файлу в<br />{0}","Введіть назву нового файлу в<br />{0}","Insert new file name in<br/>{0}","","","","","","","","","","Введите название нового файла в {0}"),
("Відміна","Відміна","Cancel","","","","","","","","","","Отмена"),
("Закачати","Закачати","Upload","","","","","","","","","","Закачать"),
("Організації","Організації","Organizations","","","","","","","","","","Организации"),
("Використання кластера організаціями","Використання кластера організаціями","Cluster usage by organizations","","","","","","","","","","Использование кластера организациями"),
("Використання кластера віртуальними організаціями гріда","Використання кластера віртуальними організаціями гріда","Cluster usage by grid virtual organizations","","","","","","","","","","Использование кластера виртуальными организациями грида"),
("Виберіть один чи кілька файлів","Виберіть один чи кілька файлів","Choose one or several files","","","","","","","","","","Выберите один или несколько файлов"),
("Створення файлу","Створення файлу","Create file","","","","","","","","","","Создать файл"),
("Запуски за кодами завершення програм","Запуски за кодами завершення програм","Task launches by exit codes","","","","","","","","","","Запуски по кодам завершения программ"),
("Запуски за кодами завершення грід-програм","Запуски за кодами завершення грід-програм","Grid task launches by exit codes","","","","","","","","","","Запуски грид-программ по кодам завершения"),
("Новий лист","Новий лист","New letter","","","","","","","","","",""),
("Ваш особистий профіль","Ваш особистий профіль","Your personal profile","","","","","","","","","","Ваш собственный профиль"),
("Видалити профіль","Видалити профіль","Delete profile","","","","","","","","","","Удалить профиль"),
("Графік навантаження та середнього часу обчислень грід-задач на кластері","Графік навантаження та середнього часу обчислень грід-задач на кластері","Cluster load and computing average graph for grid-tasks","","","","","","","","","","График нагрузки и среднего времени вычислений грид-задач на кластере"),
("Закрити","Закрити","Close","","","","","","","","","","Закрыть"),
("Глобальний профіль","Глобальний профіль","Global profile","","","","","","","","","","Общий профиль"),
("Перейти в цю теку","Перейти в цю теку","Go to folder","","","","","","","","","","Перейти в эту папку"),
("Немає прав для видалення","Немає прав для видалення","No permission for removal","","","","","","","","","","Нет прав на удаление"),
("Навантаження гріда","Навантаження гріда","Grid load","","","","","","","","","","Нагрузка кластера"),
("Індекс очікування","Індекс очікування","Expectation index","","","","","","","","","","Индекс ожидания"),
("Грід ВО","Грід ВО","Grid VO","","","","","","","","","","Грид ВО"),
("Основна","Основна","Default","","","","","","","","","","Основная"),
("Нове повідомлення","Нове повідомлення","New message","","","","","","","","","","Новое сообщение"),
("Відповісти","Відповісти","Reply","","","","","","","","","","Ответить"),
("Переслати","Переслати","Send","","","","","","","","","","Переслать"),
("Використання кластера користувачами за вибраний період","Використання кластера користувачами за вибраний період","Cluster usage by users for selected date range","","","","","","","","","","Использование кластера пользователями за выбранный период"),
("Користувачі гріда","Користувачі гріда","Grid users","","","","","","","","","","Пользователи грида"),
("Використання кластера грід-користувачами за вибраний період","Використання кластера грід-користувачами за вибраний період","Cluster usage by grid-users for selected date range","","","","","","","","","","Использование кластера грид-пользователями за выбранный период"),
("Навантаження кластера","Навантаження кластера","Cluster load","","","","","","","","","","Загрузка кластера"),
("Графік навантаження та середнього часу обчислень кластера","Графік навантаження та середнього часу обчислень кластера","Cluster load and computing average graph","","","","","","","","","","График нагрузки и среднего времени вычислений на кластере"),
("Індекс","Індекс","Index","","","","","","","","","","Индекс"),
("Графік індексу очікування ресурсів кластера","Графік індексу очікування ресурсів кластера","Cluster resource expectation index plot","","","","","","","","","","График индекса ожидания ресурсов кластера"),
("Редагувати","Редагувати","Edit","","","","","","","","","",""),
("Режим редагування","Режим редагування","Edit mode","","","","","","","","","",""),
("Файл з таким ім\'ям вже існує","Файл з таким ім\'ям вже існує","File with such name already exists","","","","","","","","","","Файл с таким именем уже существует"),
("Пошук","Пошук","Search","","","","","","","","","","Поиск"),
("Введіть параметри пошуку","Введіть параметри пошуку","Input search params","","","","","","","","","","Введите параметры поиска"),
("на вузол","на вузол","per node","","","","","","","","","","на узел"),
("Сервер","Сервер","Server","","","","","","","","","","Сервер"),
("Налаштування грід-сертифіката","Налаштування грід-сертифіката","Grid certificate settings","","","","","","","","","","Настройки грид-сертификата"),
("Використовувати для авторизації","Використовувати для авторизації","Use for authorization","","","","","","","","","","Использовать для авторизации"),
("Файл сертифіката","Файл сертифіката","Certificate file","","","","","","","","","","Файл сертификата"),
("Налаштування MyProxy","Налаштування MyProxy","MyProxy settings","","","","","","","","","","Настройки MyProxy"),
("Віртуальні організації","Віртуальні організації","Virtual organizations","","","","","","","","","","Виртуальные организации"),
("Аліас","Аліас","Alias","","","","","","","","","","Алиас"),
("Адреса сервера","Адреса сервера","Server","","","","","","","","","","Сервер"),
("Порт","Порт","Port","","","","","","","","","","Порт"),
("DN","DN","DN","DN","","","","","DN","","DN","DN","DN"),
("Видалення ВО","Видалення ВО","Delete VO","","","","","","","","","","Удалить ВО"),
("Видалити ВО \"{0}\"?","Видалити ВО \"{0}\"?","Delete VO \"{0}\"?","","","","","","","","","","Удалить ВО \"{0}\"?"),
("Час очікування","Час очікування","Wait time","","","","","","","","","",""),
("Редагування","Редагування","Edit","","","","","","","","","","Редактирование"),
("Спостереження","Спостереження","Watch","","","","","","","","","","Наблюдение"),
("Сертифікат гріда недійсний. ","Сертифікат гріда недійсний. ","Grid certificate is invalid.","","","","","","","","","","Сертификат грида недействительный"),
("Без ВО","Без ВО","Without VO","","","","","","","","","","Без ВО"),
("Налаштування приватного ключа","Налаштування приватного ключа","Private key configuration","","","","","","","","","","Настройки частного ключа"),
("Інформація про ключ","Інформація про ключ","Key information","","","","","","","","","","Информация про ключ"),
("Встановлено","Встановлено","Installed","","","","","","","","","","Установнено"),
("Відсутній","Відсутній","Absent","","","","","","","","","","Отсутствует"),
("Вузол","Вузол","Node","","","","","","","","","","Узел"),
("Температура","Температура","Temperature","","","","","","","","","","Температура"),
("За дату","За дату","","","","","","","","","","",""),
("Накопичувальна","Накопичувальна","Cumulative","","","","","","","","","","Накопительная"),
("Вибір дати","Вибір дати","Select date","","","","","","","","","","Выбор даты"),
("Приховані","Приховані","Hidden","","","","","","","","","","Скрытые"),
("Кількість","Кількість","Number","","","","","","","","","","Количество"),
("Видалення помилок","Видалення помилок","Delete errors","","","","","","","","","","Удалить ошибки"),
("Сховати виділені помилки?","Сховати виділені помилки?","Hide selected errors?","","","","","","","","","","Скрыть выделенные ошибки?"),
("Приховати виділені помилки","Приховати виділені помилки","Hide selected warnings","","","","","","","","","","Скрыть выделенные ошибки"),
("Сервіс","Сервіс","Service","","","","","","","","","","Сервис"),
("Код поповнення","Код поповнення","Recharge code","","","","","","","","","","Код пополнения"),
("Поповнити","Поповнити","Deposit","","","","","","","","","","Пополнить"),
("Поповнення рахунку","Поповнення рахунку","Account recharge","","","","","","","","","","Пополнение счета"),
("Стан модема","Стан модема","Modem status","","","","","","","","","","Состояние модема"),
("До кінця терміну дії сертифіката залишилось днів: {0}n","До кінця терміну дії сертифіката залишилось днів: {0}n","","","","","","","","","","",""),
("До кінця терміну дії сертифіката залишилось днів: {0}","До кінця терміну дії сертифіката залишилось днів: {0}","Certificate will expire after days: {0}","","","","","","","","","","До конца срока действия сертификата осталось дней: {0}"),
("","","","","","","","","","","","",""),
("Налаштування грід-ключа","Налаштування грід-ключа","","","","","","","","","","",""),
("Грід-сертифікат","Грід-сертифікат","Grid-certificate","","","","","","","","","","Грид-сертификат"),
("Грід-ключ","Грід-ключ","Grid-key","","","","","","","","","","Грид-ключ"),
("MyProxy","MyProxy","MyProxy","MyProxy","","","","","MyProxy","","MyProxy","MyProxy","MyProxy"),
("Віддалені кластери","Віддалені кластери","Remote clusters","","","","","","","","","","Удаленные кластеры"),
("Видалення","Видалення","Delete","","","","","","","","","","Удаление"),
("Видалити рядок \"{0}\"?","Видалити рядок \"{0}\"?","","","","","","","","","","",""),
("Менеджер ресурсів","Менеджер ресурсів","Resourses manager","","","","","","","","","","Менеджер ресурсов"),
("Авторизація у гріді","Авторизація у гріді","Authorization in grid","","","","","","","","","","Авторизация в гриде"),
("Видалити рядок?","Видалити рядок?","Delete row?","","","","","","","","","","Удалить строку?"),
("Доступні черги","Доступні черги","Available queues","","","","","","","","","","Доступные очереди"),
("Пропозиція пароля","Пропозиція пароля","","","","","","","","","","",""),
("Запропоновані варіанти паролів:","Запропоновані варіанти паролів:","","","","","","","","","","",""),
("Згенерувати пароль","Згенерувати пароль","","","","","","","","","","",""),
("Довжина пароля менша за 6 символів","Довжина пароля менша за 6 символів","","","","","","","","","","",""),
("Складність пароля занадто низька","Складність пароля занадто низька","","","","","","","","","","","")	;
drop table if exists `dictionary_usage`	;
CREATE TABLE `dictionary_usage` (
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `mode` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `count` int(11) NOT NULL,
  PRIMARY KEY (`name`,`mode`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci COMMENT='debug table, shows how many times each word is used'	;
drop table if exists `grid_clusters`	;
CREATE TABLE `grid_clusters` (
  `hostname` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `middleware` enum('arc','glite') COLLATE utf8_unicode_ci NOT NULL,
  `country` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `city` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `location` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `address` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `organization` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `geo_lng` double DEFAULT NULL,
  `geo_lat` double DEFAULT NULL,
  PRIMARY KEY (`hostname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
insert into `grid_clusters` VALUES 
("alice.grid.upjs.sk","arc","Slovakia","Košice","","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251001,48.719001),
("ametisti.grid.helsinki.fi","arc","Finland","Helsinki","FI-00014","","",24.949265,60.170165),
("arc.bccs.uib.no","arc","Norway","Bergen ","","Thormøhlensgate 55 N-5008 ","Uni Computing Høyteknologisenteret ",5.331,60.382),
("arc.biomed.kiev.ua","arc","Ukraine","Kyiv","","54 Volodymyrska Str.","National Scientific Centre for Medical and Biotechnical Research",30.512491,50.444883),
("arc.univ.kiev.ua","arc","Ukraine","Kyiv","","Glushkov Ave., 2, corps 6","National Taras Shevchenko University ",30.4703435115516,50.3829848823898),
("beda","arc","Sweden","Gothenburg ","SE-41296","","",11.9732001,57.690002),
("bio1.grid.upjs.sk","arc","Slovakia","Košice","SK-04001-Kosice","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251002,48.719002),
("ce01.titan.uio.no","arc","Norway","Oslo","","Boks 1072 Blindern NO-0316","The University of Oslo",10.770001,59.920001),
("ce02.titan.uio.no","arc","Norway","Oslo","","Boks 1072 Blindern NO-0316","The University of Oslo",10.770002,59.920002),
("cluster.ilt.kharkov.ua","arc","Ukraine","Kharkiv","","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.220243,50.039569),
("cluster.immsp.kiev.ua","arc","Ukraine","Kyiv","","Glushkov Avenue 42","Institute of Mathematical Machines and Systems Problems ",30.441614,50.362179),
("ds0.ilt.kharkov.ua","arc","Ukraine","Kharkiv","","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.22024301,50.03956901),
("energrid.ipme.kiev.ua","arc","Ukraine","Kyiv","","15, General Naumov Str., 03164","Pukhov Institute for Modelling in Energy Engineering",30.346186,50.474009),
("felix.iap.sumy.org","arc","Ukraine","Sumy","","Petropavlovskaya, 58 Str, 40030","Institute of Applied Physics",34.794661,50.905511),
("gateway01.dcsc.ku.dk","arc","Denmark","København","","Blegdamsvej 17 DK-2100 ","University of Copenhagen",12.572222,55.696188),
("gateway03.dcsc.ku.dk","arc","Denmark","København","","Blegdamsvej 17 DK-2100","University of Copenhagen",12.572221,55.696189),
("grad.uppmax.uu.se","arc","Sweden","Uppsala","","Box 337 SE-751 05","SNIC-UPPMAX Uppsala University ",17.6467041,59.8395871),
("grid","arc","Ukraine","Sevastopol","UA-99000","","",33.593649,44.599567),
("grid.icbge.org.ua","arc","Ukraine","Kyiv","UA-03143","148 Acad. Zabolotnoho St., 03680 ","Institute of Cell Biology and Genetic Engineering",30.478894,50.355076),
("grid.imbg.org.ua","arc","Ukraine","Kyiv","UA-03143","150, Zabolotnogo Str., 03680","Institute of Molecular Biology and Genetics",30.48229,50.35476),
("grid.ipm.lviv.ua","arc","Ukraine","Lviv","","79601, Naukova Str, 5","Physico-Mechanical Institute",24.007575,49.80222),
("grid.ire.kharkov.ua","arc","Ukraine","Kharkiv","","12 Academician Proskura Street, UA-61085","Institute of Radiophysics and Electronics",36.290707,50.046222),
("grid.isma.kharkov.ua","arc","Ukraine","Kharkiv","","60 Lenin Ave, 61001","Institute For Scintillation Materials",36.222156,50.03251),
("grid.isofts.kiev.ua","arc","Ukraine","Kyiv","","40, Glushkov Ave","Institute of Software Systems",30.4458824358881,50.3638279273261),
("grid.uio.no","arc","Norway","Oslo","","Boks 1072 Blindern NO-0316","The University of Oslo",10.77,59.92),
("inparcom.kiev.ua","arc","Ukraine","Kyiv","","4 Okruzhna Rd 03180","Inparcom",30.356184,50.42949),
("jeannedarc.hpc2n.umu.se","arc","Sweden","Umeå","","SE-901 87","Umeå University ",20.305,63.819),
("jost.arnes.si","arc","Slovenia","Ljubljana","","Tehnološki park 18","Tehnološki park",14.4604444,46.0499444),
("jotunn.rhi.hi.is","arc","Iceland","Reykjavík","","Sturlugötu 8 101 ","Reiknistofnun Háskóla Íslands",-21.95,64.137),
("kiniini.csc.fi","arc","Finland","Espoo","FI-02000","Keilaranta 14, Keilaniemi","Life Science Center",24.832878,60.178),
("korundi.grid.helsinki.fi","arc","Finland","Helsinki","","","",24.919475,60.22416),
("liuske.csc.fi","arc","Finland","Espoo","FIN-02101","Keilaranta 14, Keilaniemi","Life Science Center",24.83288,60.178004),
("lscf.nbi.dk","arc","Denmark","København","","Blegdamsvej 17 2100 ","Niels Bohr Institutet ",12.572223,55.696187),
("master.ri.kharkov.ua","arc","Ukraine","Kharkiv","","Krasnoznamennaya, 4 Str, 61002","Radioastronomical Institute",36.244129,50.000222),
("midas.iop.kiev.ua","arc","Ukraine","Kyiv","","46 Prospect Nauki UA-03028","Institute of Physics",30.528221,50.386503),
("morpheus.dcgc.dk","arc","Denmark","København","DK-2100","Dansk Center for Grid Computing","Dansk Center for Grid Computing",12.572224,55.696186),
("murska","arc","Finland","Espoo","FI-2101","","",24.832876,60.178003),
("neolith2.nsc.liu.se","arc","Sweden","Linköping ","SE-58483","SE-581 83 ","Linköping University",15.575438,58.399958),
("ng.ikd.kiev.ua","arc","Ukraine","Kyiv","","Glushkov Avenue 40","Space Research Institute ",30.443178769201,50.3621121949331),
("nordug.bitp.kiev.ua","arc","Ukraine","Kyiv","","14-b, Metrolohichna Street","Bogolyubov Institute for Theoretical Physics",30.47621,50.349825),
("norgrid.bccs.uib.no","arc","Norway","Bergen ","","Thormøhlensgate 55 N-5008 ","Uni Computing Høyteknologisenteret ",5.331001,60.382001),
("norgrid.uit.no","arc","Norway","Tromsø","NO-9037","Romssa universitehta. N-9037 ","University of Tromsø",18.975,69.68),
("pamela.imp.kiev.ua","arc","Ukraine","Kyiv","","bulv Akademika Vernadskogo, 36","Institute of metallophysics",30.362841,50.466458),
("pgs03.grid.upjs.sk","arc","Slovakia","Košice","04001","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251,48.719),
("pikolit.ijs.si","arc","Slovenia","Ljubljana","","Jamova cesta 39","Institut Jožef Stefan",14.488199,46.04278),
("pinela.ijs.si","arc","Slovenia","Ljubljana","SI-1000","Jamova cesta 39","Institut Jožef Stefan",14.487726,46.042972),
("pythia.tcs.hut.fi","arc","Finland","Espoo","FI-02015","Konemiehentie 2, FI-02150","Aalto University",24.822664,60.187153),
("siri.lunarc.lu.se","arc","Sweden","Lund","","SE-221 00 Paradisgatan 2","Lund University",13.195,55.7062),
("svea.c3se.chalmers.se","arc","Sweden","Gothenburg ","","SE-412 96","Chalmers University of Technology",11.9732,57.69),
("testbed","arc","Slovakia","Košice","SK-04001-Kosice","","",21.251008,48.719008),
("thei.org.ua","arc","Ukraine","Simferopol","","Sevastopolskaya Str, 62","Tavriya Humanitarian Ecological Institute",34.0920989960432,44.9368711779363),
("uagrid.org.ua","arc","Ukraine","Kyiv","UA-03143","40, Glushkov ave.","V.M. Glushkov Institute of Cybernetics",30.443238,50.362562),
("vls.grid.upjs.sk","arc","Slovakia","Košice","","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251003,48.719003),
("golowood.mao.kiev.ua","arc","Ukraine","Kyiv","","27 Akademika Zabolotnoho St. 03680 ","Main Astronomical Observatory",30.496672,50.363869),
("ng.tntu.edu.ua","arc","Ukraine","Ternopil","UA-46000","","Ternopil Ivan Pul’uj National Technical University",25.6009216234088,49.551079325315),
("usva.fgi.csc.fi","arc","Finland","Espoo","","Keilaranta 14, Keilaniemi","Life Science Center",24.832879,60.178001),
("arc.hpcc.kpi.ua","arc","Ukraine","Kyiv","UA-03143","37, Peremohy Ave","NTUU KPI",30.456097,50.449867),
("nordu.hpcc.ntu-kpi.kiev.ua","arc","Ukraine","Kyiv","UA-03143","37, Peremohy Ave","NTUU KPI",30.456099,50.449869),
("vm009.gla.scotgrid.ac.uk","arc","UK","Glasgow","","","ScotGrid",-4.210975,55.847979),
("fyrgrid.grid.aau.dk","arc","Denmark","Aalborg","DK-9220","Fredrik Bajers Vej 5","Aalborg University",9.98683,57.0172),
("grid.tsl.uu.se","arc","Sweden","Uppsala","","","TSL Uppsala University",17.646704,59.839587),
("ce.grid.su.lt","arc","Lithuania","Šiauliai","","Vilniaus st. 88 LT-76285","Šiauliai University",23.326421,55.925439),
("simulator.imath.kiev.ua","arc","Ukraine","Kyiv","","3, Tereschenkivska str.","Institute of Mathematics",30.516071,50.444647),
("pgs02.grid.upjs.sk","arc","Slovakia","Košice","04001","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251004,48.719004),
("nordugrid.spbu.ru","arc","Russia","Saint Petersburg","","7-9, Universitetskaya nab.","Saint Petersburg State University",30.298126,59.940364),
("arc.bitp.kiev.ua","arc","Ukraine","Kyiv","UA-03143","14-b, Metrolohichna Street","Bogolyubov Institute for Theoretical Physics",30.476208,50.349823),
("topaasi.grid.utu.fi","arc","Finland","Turku","FI-20014","","University of Turku",22.287751,60.454372),
("arc.imbg.org.ua","arc","Ukraine","Kyiv","","150, Zabolotnogo Str., 03680","Institute of Molecular Biology and Genetics",30.482291,50.354761),
("iep.org.ua","arc","Ukraine","Uzhgorod","UA-88017","Universitetska str. 21","Institute of Electron Physics",22.28847,48.635745),
("krokar.ijs.si","arc","Slovenia","Ljubljana","","Jamova cesta 39","Institut Jožef Stefan",14.4877261,46.0429721),
("cuda1.grid.upjs.sk","arc","Slovakia","Košice","SK-04001-Kosice","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251005,48.719005),
("ds2.ilt.kharkov.ua","arc","Ukraine","Kharkiv","UA-61103","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.22024302,50.03956902),
("west.icmp.lviv.ua","arc","Ukraine","Lviv","","1 Svientsitskii Street","Institute for Condensed Matter Physics",24.034159,49.827477),
("hpc.mhi.iuf.net","arc","Ukraine","Sevastopol","UA-99011","2 Kapitanska St.","Marine Hydrophysical Institute",33.517957,44.615446),
("ui.ilt.kharkov.ua","arc","Ukraine","Kharkiv","UA-61103","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.22024303,50.03956903),
("se.ilt.kharkov.ua","arc","Ukraine","Kharkiv","UA-61103","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.22024304,50.03956904),
("grid.ifbg.org.ua","arc","Ukraine","Kyiv","","Оsipovskogo str., 2A","Institute of Food Biotechnology and Genomics",30.445261,50.514382),
("arcnox.bitp.kiev.ua","arc","Ukraine","Kyiv","DK-2100","14-b, Metrolohichna Street","Bogolyubov Institute for Theoretical Physics",30.476211,50.349829),
("cluster.iep.org.ua","arc","Ukraine","Uzhgorod","","Universitetska str. 21","Institute of Electron Physics",22.288471,48.6357451),
("grid.imag.kiev.ua","arc","Ukraine","Kyiv","","36-b Vernadsky Blvd ","Institute of Magnetism",30.363894,50.46697),
("zorro.ung.si","arc","Slovenia","Nova Gorica","SI-5000","Vipavska 13, Rožna Dolina ","University of Nova Gorica ",13.640599,45.942824),
("trebuchet.ijs.si","arc","Slovenia","Ljubljana","","Jamova cesta 39","Institut Jožef Stefan",14.4877262,46.0429722),
("grid.triton.aalto.fi","arc","Finland","Espoo","","Lämpömiehenkuja 2","Aalto University",24.831569,60.182448),
("juur.grid.eenet.ee","arc","Estonia","Tartu","","Raekoja plats 14","Estonian Grid Project EENet",26.722956,58.380512),
("meja.arnes.si","arc","Slovenia","Ljubljana","","Tehnološki park 18","Tehnološki park",14.46044441,46.04994441),
("ng.grid.fcss.ukma.kiev.ua","arc","Ukraine","Kyiv","","Skovorody St., 2","National University of Kyiv-Mohyla Academy",30.519462,50.465317),
("square.arctur.si","arc","Slovenia","Nova Gorica","","Industrijska cesta 5","Arctur Universe",13.666606,45.955968),
("saraksh.ipms.kiev.ua","arc","Ukraine","Kyiv","","Krzhizhanovsky str., 3","Frantsevich Institute for Problems of Materials Science",30.37091,50.469989),
("ds4.ilt.kharkov.ua","arc","Ukraine","Kharkiv","","47 Lenin Ave.","B.Verkin Institute for Low Temperature Physics and Engineering",36.22024305,50.03956905),
("grid.ipms.kiev.ua","arc","Ukraine","Kyiv","","Krzhizhanovsky str., 3","Frantsevich Institute for Problems of Materials Science",30.370911,50.4699891),
("arc.hpc-mhi.org","arc","Ukraine","Sevastopol","","2 Kapitanska St.","Marine Hydrophysical Institute",33.5179571,44.6154461),
("cluster-fti.ac.donetsk.ua","arc","Ukraine","Donetsk","","R.Luxembourg str., 72","Donetsk Institute for Physics and Engineering named after O.O. Galkin",37.791488,48.019482),
("vuori-arc.csc.fi","arc","Finland","Espoo","","Keilaranta 14, Keilaniemi","Life Science Center",24.8328791,60.1780011),
("pleione-grid.utu.fi","arc","Finland","Turku","","","University of Turku",22.287759,60.454376),
("aesyle-grid.fgi.csc.fi","arc","Finland","Espoo","","Keilaranta 14, Keilaniemi","Life Science Center",24.8328792,60.1780012),
("electra-grid.chem.jyu.fi","arc","Finland","Jyväskylä","","Seminaarinkatu 15","University of Jyväskylä",25.732684,62.235814),
("asterope-grid.abo.fi","arc","Finland","Turku","","Tuomiokirkontori 3","Åbo Akademi University",22.277291,60.451155),
("taygeta-grid.oulu.fi","arc","Finland","Oulu","","Pentti Kaiteran katu 1","University of Oulu",25.466352,65.059248),
("alcyone-grid.grid.helsinki.fi","arc","Finland","Helsinki","","","",24.9194751,60.224161),
("maia-grid.uef.fi","arc","Finland","Joensuu","","Yliopistokatu 2","University of Eastern Finland",29.74411,62.603986),
("merope-grid.cc.tut.fi","arc","Finland","Tampere","","Korkeakoulunkatu 10","Tampere University of Technology",23.859944,61.45005),
("celaeno-grid.lut.fi","arc","Finland","Lappeenranta","","Skinnarilankatu 34","Lappeenranta University of Technology",28.092299,61.065263),
("jade-cms.hip.fi","arc","Finland","Helsinki","","Gustaf Hällströmin katu 2","Helsinki Institute of Physics",24.962246,60.203748),
("alarik-grid.lunarc.lu.se","arc","Sweden","Lund","","SE-221 00 Paradisgatan 2","Lund University",13.1951,55.70621),
("arc-ce.smokerings.nsc.liu.se","arc","Sweden","Linköping ","","SE-58483","Linköping University",15.5754381,58.3999581),
("arc-ce01.pdc.kth.se","arc","Sweden","Stockholm","","Valhallavägen 79","KTH Royal Institute of Technology",18.073797,59.346605),
("vm-server2.grid.upjs.sk","arc","Slovakia","Košice","","Šrobárova 2 ","Univerzita Pavla Jozefa Šafárika",21.251006,48.719006),
("arc-edu.hpcc.kpi.ua","arc","Ukraine","Kyiv","","37, Peremohy Ave","NTUU KPI",30.456099,50.449869),
("phys25.gridzone.ru","arc","","","","","",\N,\N),
("cluster-edu.wups.lviv.ua","arc","","","","","",\N,\N),
("ce.imbg.org.ua","arc","","","","","",\N,\N),
("login.debrecen.hpc.niif.hu","arc","","","","","",\N,\N),
("arc-emi.bitp.kiev.ua","arc","","","","","",\N,\N)	;
drop table if exists `grid_resources`	;
CREATE TABLE `grid_resources` (
  `hostname` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `title` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `type` enum('idle','alloc') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'idle',
  `nodes_count` int(11) NOT NULL DEFAULT '0',
  `cores_count` int(11) NOT NULL DEFAULT '0',
  `time_limit` int(11) NOT NULL DEFAULT '0',
  `memory_per_node` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`hostname`,`title`,`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
drop table if exists `grid_tasks`	;
CREATE TABLE `grid_tasks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `task_id` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `hostname` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `task_name` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `work_dir` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `login` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `middleware` varchar(20) COLLATE utf8_unicode_ci NOT NULL,
  `loading` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `login` (`login`),
  KEY `loading` (`loading`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
drop table if exists `languages`	;
CREATE TABLE `languages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `short` char(2) COLLATE utf8_unicode_ci DEFAULT NULL,
  `full` char(255) COLLATE utf8_unicode_ci DEFAULT NULL,
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `position` int(11) DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=FIXED	;
insert into `languages` VALUES 
(1,"uk","Українська",1,0),
(2,"en","English",1,1),
(3,"de","Deutsch",1,2),
(4,"sv","Svenska",1,3),
(5,"no","Norske",1,4),
(6,"it","Italiano",1,5),
(7,"es","Español",1,6),
(8,"fr","Française",1,7),
(9,"fi","Suomi",1,8),
(10,"bg","Български",1,9),
(11,"cs","České",1,10),
(12,"ru","Русский",1,11)	;
drop table if exists `error_log`	;
CREATE TABLE `error_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `ip` varchar(30) COLLATE utf8_unicode_ci NOT NULL,
  `login` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `post` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `php_errors` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `hctl_user_command` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `hctl_user_errors` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `hctl_admin_command` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `hctl_admin_errors` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
drop table if exists `messages`	;
CREATE TABLE `messages` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `to_login` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `from_login` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `subject` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `message` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  `unread` tinyint(1) DEFAULT '1',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=DYNAMIC	;
drop table if exists `profiles`	;
CREATE TABLE `profiles` (
  `login` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `title` varchar(255) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `profile` text COLLATE utf8_unicode_ci NOT NULL,
  `global` tinyint(1) NOT NULL DEFAULT '0',
  `description` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`login`,`title`),
  KEY `global` (`global`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=DYNAMIC	;
insert into `profiles` VALUES 
("event","hostname","{\"partition\":\"lite_task @ icybcluster.org.ua\",\"task_name\":\"hostname\",\"runtime\":\"mpi\",\"file_name\":\"hostname\",\"time_limit\":\"1\",\"processors\":\"1\",\"cores_per_node\":\"1\"}",1,"Simple hostname task"),
("event","grid-hostname","{\"partition\":\"gridlong @ cluster.ilt.kharkov.ua\",\"task_name\":\"grid-hostname\",\"runtime\":\"custom\",\"file_name\":\"\\/bin\\/hostname\",\"time_limit\":\"1\",\"processors\":\"1\"}",1,"Simple hostname task for grid"),
("","hostname","{\"partition\":\"scit3 @ yoursite.com\",\"task_name\":\"hostname\",\"runtime\":\"mpi\",\"file_name\":\"hostname\",\"time_limit\":\"1\",\"processors\":\"1\"}",0,"Simple hostname task"),
("","grid-hostname","{\"partition\":\"gridlong @ cluster.ilt.kharkov.ua\",\"task_name\":\"grid-hostname\",\"runtime\":\"custom\",\"file_name\":\"\\/bin\\/hostname\",\"time_limit\":\"1\",\"processors\":\"1\"}",0,"Simple hostname task for grid"),
("","grid-sleep","{\"partition\":\"gridlong @ cluster.ilt.kharkov.ua\",\"task_name\":\"grid-sleep\",\"runtime\":\"custom\",\"file_name\":\"\\/bin\\/sleep\",\"parameters\":\"600\",\"time_limit\":\"20\",\"processors\":\"1\"}",0,"Simple sleep task for grid, 10 minutes"),
("","sleep","{\"partition\":\"lite_task @ icybcluster.org.ua\",\"task_name\":\"sleep\",\"runtime\":\"mpi\",\"file_name\":\"sleep\",\"parameters\":\"600\",\"time_limit\":\"20\",\"processors\":\"1\"}",0,"Simple sleep task for 10 minutes")	;
drop table if exists `reg_requests`	;
CREATE TABLE `reg_requests` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `dt` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `satisfied` tinyint(1) NOT NULL DEFAULT '0',
  `name` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `phone` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `email` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `description` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `address` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `organization` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `category` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `login` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `password` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=DYNAMIC	;
drop table if exists `remote_clusters`	;
CREATE TABLE `remote_clusters` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `login` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `host` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `resource_manager` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `remote_login` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `queues` mediumtext COLLATE utf8_unicode_ci NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
drop table if exists `users`	;
CREATE TABLE `users` (
  `login` varchar(40) COLLATE utf8_unicode_ci NOT NULL DEFAULT '',
  `is_admin` tinyint(1) NOT NULL DEFAULT '0',
  `grid_auth_mode` enum('cert','myproxy') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'cert',
  `cert_password` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `cert_auto` tinyint(1) NOT NULL DEFAULT '0',
  `myproxy_server` varchar(255) COLLATE utf8_unicode_ci NOT NULL,
  `myproxy_login` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `myproxy_password` varchar(40) COLLATE utf8_unicode_ci NOT NULL,
  `myproxy_auto` tinyint(1) NOT NULL DEFAULT '0',
  `default_vo_alias` varchar(50) COLLATE utf8_unicode_ci NOT NULL,
  `last_visit` int(11) NOT NULL,
  `loading_clusters` int(1) unsigned NOT NULL DEFAULT '0' COMMENT 'last timestamp when clusters were loaded',
  PRIMARY KEY (`login`),
  KEY `grid_mode` (`grid_auth_mode`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci ROW_FORMAT=FIXED	;
drop table if exists `users_to_clusters`	;
CREATE TABLE `users_to_clusters` (
  `login` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `hostname` varchar(100) COLLATE utf8_unicode_ci NOT NULL,
  `avaliability` enum('unknown','up','down','fail','ill') COLLATE utf8_unicode_ci NOT NULL DEFAULT 'unknown',
  PRIMARY KEY (`login`,`hostname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci	;
