<?
header('Content-Type: application/json; charset=utf-8');

ob_start("ob_gzhandler");

include('../site/start.php');

if (defined('_mon_mysql_host') and defined('_mon_mysql_login') and defined('_mon_mysql_pass')) {
	$mysql_mon = mysql_connect(_mon_mysql_host, _mon_mysql_login, _mon_mysql_pass, true);
	mysql_select_db(_mon_mysql_db, $mysql_mon);
	mysql_query('set names utf8', $mysql_mon);
}

session_start();

$user = $_SESSION['user'];

if (!$user) {
 header('HTTP/1.0 401 Unauthorized');
 exit();
}

$row = mysql_fetch_assoc(mysql_query('select is_admin from users where login = "'.$user['user_login'].'"', $mysql_main));
$user['is_admin'] = $row['is_admin'];

mysql_query('update users set last_visit = '.time().' where login = "'.$user['work_login'].'"', $mysql_main);

$cmd = $_REQUEST['cmd']; // one command
$cmds = $_REQUEST['cmds']; // list of commands

if (!is_array($cmds)) {
 $cmds = array($cmd);
}

function loadProfiles($login, $is_admin) {
 global $mysql_main;
		// profiles
	$a = array();
	$result = mysql_query('select * from profiles where login = "'.$login.'" or login = "" order by title', $mysql_main);
	while ($row = mysql_fetch_assoc($result)) {
		$row['profile'] = json_decode($row['profile'], true);
		$row['profile']['make'] = (bool)$row['profile']['make'];
		$row['global'] = !(bool)$row['login'];
		$a[] = $row;
	}
	
	return $a;
}

function clusters($login) {
 global $mysql_main;
	
	$a = array();
	
	$row = mysql_fetch_assoc(mysql_query('select count(*) c from users_to_clusters where login = "'.$login.'"', $mysql_main));
	
	if ($row['c'])
		$result = mysql_query('select gc.hostname, gc.country, gc.city, gc.organization, gc.address, gc.location, gc.geo_lng, gc.geo_lat, utc.avaliability avail '.
																								'from grid_clusters gc '.
																								'left join users_to_clusters utc on utc.hostname = gc.hostname '.
																								'where utc.login = "'.$login.'"', $mysql_main);
	else
		$result = mysql_query('select gc.hostname, gc.country, gc.city, gc.organization, gc.address, gc.location, gc.geo_lng, gc.geo_lat '.
																								'from grid_clusters gc', $mysql_main);
		
	while ($row = mysql_fetch_assoc($result)) 
		$a[] = $row;
		
	return $a;	
}

function remoteClusters($login) {
 global $mysql_main;
	$a = array();
 $result = mysql_query('select id, host, remote_login, resource_manager, queues from remote_clusters '.
	                      'where login = "'.addslashes($login).'"', $mysql_main);
 while ($row = mysql_fetch_assoc($result))
  $a[] = $row;
	return $a;
}

$mysql_output = $hydra_special_commands = $hydra_user_commands = $hydra_admin_commands = array();

// close session to release concurrent connections
if (!in_array('init', $cmds))
 session_write_close();

$debug = (defined('_debug_mode') and _debug_mode);
$log_errors = (defined('_log_errors') and _log_errors);

$hydra_user_output = $hydra_admin_output = '';
$_hctl_user_errors = $_hctl_admin_errors = '';

// group hydra commands before execution, for user and admin separately
// non-hydra (mysql) commands are executed at once, result is stored in $mysql_output
foreach ($cmds as $cmd)
 if (file_exists('commands/'.$cmd.'.php'))
	 include('commands/'.$cmd.'.php');
 else
	 $_php_errors .= $cmd.": command missing.\n";
		
// execute hydra commands

foreach ($hydra_special_commands as $command) {
	if ($debug or $log_errors) {
 	$_hctl_user_command .= $command['cmd']."\n";
	}
	
 connect_hydra($command['cmd'], $command['params'], $hydra_user_output, $_hctl_user_errors);
}

if (sizeof($hydra_user_commands)) {
 $cmd = _hydra_hctl.' -i '._hydrad_host.' -u '.$user['work_login'].' hydra ';
 $params = json_encode($hydra_user_commands);
	
	if ($debug or $log_errors) {
 	$_hctl_user_command .= $cmd.$params;
		if ($debug)
		 $mysql_output['_debug_user_cmd'] .= $_hctl_user_command."\n";
	}
	
	connect_hydra($cmd, $params, $hydra_user_output, $_hctl_user_errors);	
}	

if (sizeof($hydra_admin_commands) and _scms == 'pro') {
	$cmd = _hydra_hctl.' -i '._hydrad_host.' -u '._portal_admin_uid.' hydra ';
	$params = json_encode($hydra_admin_commands);
	
 if ($debug or $log_errors) {
	 $_hctl_admin_command .= $cmd.$params;
		if ($debug)
  	$mysql_output['_debug_admin_cmd'] .= $_hctl_admin_command."\n";
 }

	connect_hydra($cmd, $params, $hydra_admin_output, $_hctl_admin_errors);		
}	

$_php_errors = addcslashes($_php_errors, "\\\'\"\n\r");

if ($debug or $log_errors) {
 $_hctl_user_errors = addcslashes($_hctl_user_errors, "\\\'\"\n\r");
 $_hctl_admin_errors = addcslashes($_hctl_admin_errors, "\\\'\"\n\r");
}

// collect all three outputs into one JSON encoded string without decoding-encoding hydra output (for greater speed)
// simply stripping curly brackets at the beginning and the end of each JSON output and concatenating them with comma.
$a = array();
if (sizeof($mysql_output))
	$a[] = substr(json_encode($mysql_output), 1, -1);
if ($hydra_user_output)
 $a[] = $hydra_user_output;
if ($hydra_admin_output)
 $a[] = $hydra_admin_output;

$a = sizeof($a) ? '"success":true,'.implode(',', $a) : '';

$out = array();
if ($a)
 $out[] = $a;
if ($debug and $_php_errors)
 $out[] = '"php errors":"'.$_php_errors.'"';
if ($debug and $_hctl_user_errors)
 $out[] = '"hctl user errors":"'.$_hctl_user_errors.'"';
if ($debug and $_hctl_admin_errors)
 $out[] = '"hctl admin errors":"'.$_hctl_admin_errors.'"';

echo '{'.implode(',', $out).'}';

if ($log_errors and ($_php_errors or $_hctl_user_errors or $_hctl_admin_errors))
 mysql_query('insert error_log (ip, login, post, php_errors, hctl_user_command, hctl_user_errors, hctl_admin_command, hctl_admin_errors) values '.
	            '("'.$_SERVER['REMOTE_ADDR'].'", "'.$user['work_login'].'", "'.addslashes(json_encode($_POST)).'", "'.$_php_errors.'", '.
													'"'.addslashes($_hctl_user_command).'", "'.$_hctl_user_errors.'", '.
													'"'.addslashes($_hctl_admin_command).'", "'.$_hctl_admin_errors.'")', $mysql_main);
?>